/*  DO NOT EDIT THIS FILE.

    It has been auto-edited by fixincludes from:

	"/usr/include/kcms/kcs.h"

    This had to be done to correct non-standard usages in the
    original, manufacturer supplied header file.  */

#pragma ident "@(#)kcs.h	1.11  04/14/98"
#ifndef __Kcs__
#define __Kcs__

/*----------------------------------------------------------------------*\
|  To the developer:  We at Kodak are sincerely sorry for the cryptic nature 
|             of this header file.  Unfortunately, that is the price 
|             one pays for platform independent header files.
|
|               kcs.h
|        
|            External "C" API to Kodak Color Sense.
|        
|        
|   static char sccsid[] = "mainline @(#)kcs.h	1.1 18 Feb 1994";
|
\*----------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

#if  defined(applec) || defined(THINK_C)
#define KCS_ON_MAC
#endif
#ifdef _Windows
#define KCS_ON_WINDOWS
#endif

#if defined (__sun) || defined(__sun__) 
#undef KCS_ON_SOLARIS
#define KCS_ON_SOLARIS
#endif /* __sun, __unix */

#if defined (__unix)
/* Specific Variants TBD... */
#define KCS_ON_UNIX
#endif

#ifdef KCS_ON_WINDOWS
#  define KCS_PTR _far*
#  define KCS_PASC(X) X  _far _pascal
#  define KCS_CALLBK(X) X _far _pascal
#  define KCS_INLINE_ASM( selector, argsize )
#endif /* KCS_ON_WINDOWS */

#ifdef KCS_ON_SOLARIS
#include <sys/isa_defs.h>   

/* alert on the lack of 64 bit libraries on Solaris */
#if defined(_LP64)
#error "KCMS is not available for the 64 bit version of Solaris"
#endif
#  define KCS_PTR *
#  define KCS_PASC(X) X
#  define KCS_CALLBK(X) X
#  define KCS_INLINE_ASM( selector, argsize )
#  define KCS_pascal /* nothing */
#endif /* KCS_ON_SOLARIS */


#ifdef KCS_ON_MAC
#  define KCS_PTR *
#  define KCS_CALLBK(X) X

#  define KCS_gestaltKcs         'Kcs '

#  ifndef KCS_LINKABLE_INTERFACE
#        define KCS_INLINE_ASM( selector, argsize ) =  { 0x2f00, \
	   0x203c, 0x4b63, 0x7320, 0xa1ad, 0x4a40, 0x670e, 0x201f, \
	   0xdefc, argsize, 0x2ebc, 0x0000, 0x4054, 0x6016, 0x201f, \
	   0x42a7, 0x2f3c, argsize, selector, 0x4e90, 0x205f, 0xb0fc, \
	   0x0000, 0x67e0, 0x4e90, 0x4e71  }

        /*
	   The following selector codes must be non arithmetic defines
	   and not enums.  C++ converts both to long by default and
	   hoses the macintosh inline code!
         */
#        define         pKcsSelectorStart        0x0000
#        define         pKcsLoadProfile          0x0000
#        define         pKcsSaveProfile          0x0001
#        define         pKcsFreeProfile          0x0002
#        define         pKcsReserved0003         0x0003
#        define         pKcsReserved0004         0x0004
#        define         pKcsGetAttribute         0x0005
#        define         pKcsSetAttribute         0x0006
#        define         pKcsReserved0007         0x0007
#        define         pKcsReserved0008         0x0008
#        define         pKcsConnectProfiles      0x0009
#        define         pKcsOptimizeProfile      0x000A
#        define         pKcsEvaluate             0x000B
#        define         pKcsReserved000C         0x000C
#        define         pKcsReserved000D         0x000D
#        define         pKcsReserved000E         0x000E
#        define         pKcsModifyLoadHints      0x000F
#        define         pKcsSetCallback          0x0010
#        define         pKcsCreateProfile        0x0011  
#        define         pKcsUpdateProfile        0x0012  
#        define         pKcsGetSimpleAttribute   0x0013  
#        define         pKcsSetSimpleAttribute   0x0014  
#        define         pKcsAvailable            0x0015  
#        define         pKcsGetLastError         0x0016  
        /* Note: increment this when adding selector codes!!! */        
#        define         pKcsLastSelector         0x0017  

		 /* Inline/gestalt MUST be pascal calling conventions */
#  		 define KCS_PASC(X) pascal X

#     else
#        define KCS_INLINE_ASM( selector, argsize ) 
#  		 define KCS_PASC(X) X

#  endif /* KCS_LINKABLE_INTERFACE */


#endif /* KCS_ON_MAC */

#include "kcstypes.h"

/*
 * ColorSense Color Engine Function Prototypes
 */

KCS_PASC(KcsStatusId)
KcsLoadProfile (
                KcsProfileId               KCS_PTR profile,
                KcsProfileDesc          KCS_PTR desc,
                KcsLoadHints                    loadHints
)  KCS_INLINE_ASM( pKcsLoadProfile, 0x000C);


KCS_PASC(KcsStatusId)
KcsSaveProfile (
                KcsProfileId                      profile,
                KcsProfileDesc         KCS_PTR desc
)  KCS_INLINE_ASM( pKcsSaveProfile,  0x0008);


KCS_PASC(KcsStatusId)
KcsFreeProfile (
                KcsProfileId                      profile
)  KCS_INLINE_ASM( pKcsFreeProfile,  0x0004);


KCS_PASC(KcsStatusId)
KcsGetAttribute (
                KcsProfileId                      profile, 
                KcsAttributeName             name,
                KcsAttributeValue     KCS_PTR value
)  KCS_INLINE_ASM( pKcsGetAttribute, 0x000C);


KCS_PASC(KcsStatusId)
KcsSetAttribute (
                KcsProfileId                      profile, 
                KcsAttributeName             name,
                KcsAttributeValue      KCS_PTR value
)  KCS_INLINE_ASM( pKcsSetAttribute, 0x000C);


KCS_PASC(KcsStatusId)
KcsConnectProfiles (
                KcsProfileId               KCS_PTR resultProfileId,
                unsigned long                    profileCount,
                KcsProfileId               KCS_PTR profileSequence,
                KcsOperationType              operationLoadSet,
                unsigned long             KCS_PTR failedProfileIndex
)  KCS_INLINE_ASM( pKcsConnectProfiles,  0x0014);


KCS_PASC(KcsStatusId)
KcsOptimizeProfile (
                KcsProfileId                      profile,
                KcsOptimizationType         optimizationType,
                KcsLoadHints                    operationLoadSet
)  KCS_INLINE_ASM( pKcsOptimizeProfile, 0x000C);


KCS_PASC(KcsStatusId)
KcsEvaluate (
                KcsProfileId                      profile,
                KcsOperationType             operation,
                KcsPixelLayout          KCS_PTR srcData,
                KcsPixelLayout          KCS_PTR destData
)  KCS_INLINE_ASM( pKcsEvaluate, 0x0010);


KCS_PASC(KcsStatusId)
KcsModifyLoadHints (
                KcsProfileId                      profile,
                KcsLoadHints                    newHints
)  KCS_INLINE_ASM( pKcsModifyLoadHints, 0x0008);


KCS_PASC(KcsStatusId)
KcsSetCallback (
                KcsFunction                      function,
                KcsCallbackFunction          callback,
                void                           KCS_PTR userDefinedData
)  KCS_INLINE_ASM( pKcsSetCallback, 0x000C);



KCS_PASC(KcsStatusId)
KcsCreateProfile (
                KcsProfileId               KCS_PTR resultProfileId,
                KcsCreationDesc            KCS_PTR cmmId
)  KCS_INLINE_ASM( pKcsCreateProfile, 0x0008);


KCS_PASC(KcsStatusId)
KcsUpdateProfile (
                KcsProfileId                      profile,
                KcsCharacterizationData   KCS_PTR charact,
                KcsCalibrationData            KCS_PTR calib,
		void                      KCS_PTR CMMSpecificData
)  KCS_INLINE_ASM( pKcsUpdateProfile, 0x0010);

KCS_PASC(KcsStatusId)
KcsAvailable (
				long KCS_PTR response
) KCS_INLINE_ASM( pKcsAvailable, 0x0004);

KCS_PASC(KcsStatusId)
KcsGetLastError (
                KcsErrDesc	KCS_PTR errDesc 
)  KCS_INLINE_ASM( pKcsGetLastError, 0x0004);




#ifdef __cplusplus
}
#endif
#endif /* __KCS_H__ */
